<div
  *ngIf="tableConfig?.titleText"
  class="title__container"
  [ngClass]="{ 'ecl-u-mb-xs': tableConfig?.descriptionText, 'ecl-u-mb-l': !tableConfig?.descriptionText }">
  <h2 class="title__text ecl-u-type-bold">{{ tableConfig?.titleText | translate }}</h2>
  <span *ngIf="tableConfig?.showTotalCount" eclLabel class="title__count-label ecl-u-bg-branding" variant="highlight">{{
    dataSource.length
  }}</span>
</div>

<div *ngIf="tableConfig?.descriptionText" class="ecl-u-mb-l">
  <p eclPageHeaderDescription class="description">{{ tableConfig?.descriptionText | translate }}</p>
</div>

<div *ngIf="isMobile && hasTooltip()" class="tooltip-mobile__container">
  <img class="tooltip-mobile__icon" src="assets/icons/info-icon.svg" alt="" />
  *
  <div class="tooltip-mobile__content">
    <span *ngFor="let text of getTooltipText()">{{ text | translate }}</span>
  </div>
</div>

<table eclTable class="table__wrapper" (sort)="sort($event)">
  <caption *ngIf="tableConfig?.captionText" class="ecl-u-sr-only">{{ tableConfig?.captionText }}</caption>
  <thead eclTableHead>
    <tr eclTableRow>
      <th *ngIf="tableConfig?.isExpandable" class="ecl-u-ph-none" aria-hidden="true"></th>
      <th
        *ngFor="let column of tableData.header"
        eclTableHeader
        class="column"
        [eclSortable]="checkSortableColumn(column.id)"
        [ngStyle]="{ width: getColumnWidth(column.id) }">
        {{ column.name | translate }}
        <div *ngIf="!isMobile && column.tooltipText" class="column__icon">
          <img class="column__icon" src="assets/icons/info-icon.svg" alt="" />
          <div class="column__tooltip">
            <span *ngFor="let text of column.tooltipText">{{ text | translate }}</span>
          </div>
        </div>
      </th>
    </tr>
  </thead>

  <!-- Table Body -->
  <tbody *ngIf="tableContent.length > 0" aria-live="polite" [ngClass]="{ 'column-spacer': tableConfig?.columnSpacer }">
    <ng-container *ngFor="let row of tableContent">
      <tr
        eclTableRow
        class="table__row ee-no-border-second-child"
        [ngClass]="{
          clickable: tableConfig?.clickableRows,
          'ee-row-expanded ecl-u-type-bold': row.opened
        }"
        (click)="onRowClick(row)">
        <!--  Expand row icon  -->
        <td *ngIf="tableConfig?.isExpandable" class="ee-no-right-border">
          <div class="row__container--connector-link ecl-no-right-border">
            <button
              [disabled]="row?.disableExpandableRowIcon"
              class="ee-button-no-design"
              [ngClass]="{
                'ee-opacity-30': row?.disableExpandableRowIcon,
                'eui-u-cursor-pointer': !row?.disableExpandableRowIcon
              }"
              (click)="row.opened = !row.opened">
              <ecl-icon class="ecl-icon--rotate-{{ row?.opened ? '180' : '90' }}" color="primary" [icon]="'corner-arrow'" />
            </button>
          </div>
        </td>

        <!--  Data row  -->
        <td
          *ngFor="let item of orderRowItems(row); index as i"
          eclTableCell
          [eclTableCellHeader]="getColumnHeaderName(item.columnId) | translate"
          [ngStyle]="{ width: getColumnWidth(item.columnId) }">
          <ng-container [ngSwitch]="getColumnType(item.columnId)">
            <ng-container *ngSwitchCase="tableColumnType.link">
              <ng-container *ngTemplateOutlet="link; context: { $implicit: item }" />
            </ng-container>
            <ng-container *ngSwitchCase="tableColumnType.string">
              <ng-container *ngTemplateOutlet="string; context: { $implicit: item, isClickable: tableConfig?.clickableRows }" />
            </ng-container>
            <ng-container *ngSwitchCase="tableColumnType.number">
              <ng-container *ngTemplateOutlet="number; context: { $implicit: item }" />
            </ng-container>
            <ng-container *ngSwitchCase="tableColumnType.progress">
              <ng-container *ngTemplateOutlet="progress; context: { $implicit: item }" />
            </ng-container>
            <ng-container *ngSwitchCase="tableColumnType.flag">
              <ng-container *ngTemplateOutlet="flag; context: { $implicit: item }" />
            </ng-container>
            <ng-container *ngSwitchCase="tableColumnType.event">
              <ng-container *ngTemplateOutlet="event; context: { $implicit: item }" />
            </ng-container>
            <ng-container *ngSwitchCase="tableColumnType.connector">
              <ng-container *ngTemplateOutlet="connector; context: { $implicit: item }" />
            </ng-container>
            <ng-container *ngSwitchCase="tableColumnType['link-connector']">
              <ng-container *ngTemplateOutlet="connectorLink; context: { $implicit: item }" />
            </ng-container>
          </ng-container>
        </td>
      </tr>

      <!--  Expandable row   -->
      <tr eclTableRow class="table__row ee-background-color-expanded" *ngIf="row.opened">
        <td [attr.colspan]="tableData?.header?.length + 2" class="ecl-u-ph-l ecl-u-pv-m">
          <ng-container *ngTemplateOutlet="linkedDataList; context: { $implicit: row }" />
        </td>
      </tr>
    </ng-container>
  </tbody>
</table>

<!-- Paginator -->
<div *ngIf="tableConfig?.showPaginator && dataSource.length > 5" class="paginator__container">
  <div *ngIf="!isMobile && dataSource.length > 5" class="page-selector__wrapper">
    <div class="page-selector__select">
      <span>{{ 'app.table.paginator-select.label' | translate }}</span>
      <select class="select" [formControl]="pageSizeSelector">
        <option *ngFor="let option of pageSizeOptions" [value]="option">{{ option }}</option>
      </select>
    </div>
    <span>Showing {{ paginator.showingFrom }} - {{ paginator.showingTo }} of {{ dataSource.length }}</span>
  </div>
  <ecl-pagination
    *ngIf="dataSource.length > pageSize"
    class="ecl-u-pv-none"
    [mode]="backendSortAndPagination ? 'manual' : 'auto'"
    [currentPage]="paginator.page"
    [totalItems]="dataSource.length"
    [pageSize]="pageSize"
    (page)="pagination($event)">
  </ecl-pagination>
</div>

<!-- Notification page message-->
<app-message-box
  *ngIf="dataSource.length === 0"
  [title]="messageBoxData?.title | translate"
  [description]="messageBoxData?.description | translate"
  [state]="messageBoxData?.state" />

<!--  Templates area -->
<ng-template #string let-item let-isClickable="isClickable">
  <div class="row__container--multiple">
    <div
      *ngFor="let value of item.value; index as i"
      class="row__content-container"
      [ngClass]="{ 'ecl-u-mb-m': !!getLocalName(value, 'code') && i < item.value.length - 1 }">
      <span *ngIf="!!getLocalName(value, 'code')" class="row__country-code">{{ getLocalName(value, 'code') }}</span>
      <span class="row__label" [ngClass]="{ link: isClickable && isMobile && item.valueId }">{{
        getLocalName(value, 'title') || '-'
      }}</span>
    </div>
    <span *ngIf="item.value?.length === 0" class="row__empty-label">{{ item.emptyValue | translate }}</span>
  </div>
</ng-template>

<ng-template #number let-item>
  <div class="row__container--number ecl-u-d-flex ecl-u-align-content-center ecl-u-justify-content-end">
    <ng-container *ngIf="tableConfig?.expandableRowTitle && +item.value === 0 && item.value.toString() !== '00'">
      <span [euiTooltip]="tableConfig.noDataTooltip | translate">
        <img class="ee-icon-small ecl-u-mr-2xs" src="assets/icons/no_amount_indication.png" alt="No amount" />
      </span>
    </ng-container>
    <span class="row__label">{{ item.value || '0' }}</span>
  </div>
</ng-template>

<ng-template #progress let-item>
  <div class="row__container--progress progress-item">
    <div class="row__progress-bar">
      <div class="fill" [ngStyle]="{ width: getProgressBarFill(+item.value) }"></div>
    </div>
    <span class="row__label">{{ item.value || '0' }}</span>
  </div>
</ng-template>

<ng-template #link let-item>
  <div>
    <a
      *ngIf="item.value"
      class="row__label {{ tableConfig.isExpandable ? 'link-default-color' : 'link' }}"
      (click)="onLinkClick(item.columnId, item.valueId)"
      target="_self"
      tabindex="0"
      [attr.aria-label]="'aria-label.table.link-item' | translate"
      >{{ item.value }}</a
    >
    <span *ngIf="!item.value" class="row__empty-label">{{ item.emptyValue | translate }}</span>
  </div>
</ng-template>

<ng-template #flag let-item>
  <div class="row__container--flag">
    <ecl-icon
      iconSet="flag"
      [icon]="item.flagCode?.toLowerCase() === 'czech republic' ? 'czech-republic' : item.flagCode?.toLowerCase()"
      size="m"></ecl-icon>
    <span class="ecl-u-type-bold">{{ item.value || '-' }}</span>
  </div>
</ng-template>

<ng-template #event let-item>
  <div class="row__container--event">
    <div *ngFor="let value of item.value; index as i" class="event-item">
      <img *ngIf="item.eventIcon" [src]="getEventPath(item.eventIcon[i])" alt="" />
      <span>{{ value | translate }}</span>
    </div>
  </div>
</ng-template>

<ng-template #connector let-item>
  <div class="row__container--connector">
    <span class="row__label connector ecl-u-type-bold">{{ item.value }}</span>
    <ng-container *ngIf="item.connector === 'AND'">
      <div *ngFor="let value of item.secondaryValues; index as i" class="row__content-container">
        <span class="row__connector">{{ item.connector }}</span>
        <span class="row__label">{{ item.secondaryValues[i] }}</span>
      </div>
    </ng-container>
  </div>
</ng-template>

<ng-template #connectorLink let-item>
  <div class="row__container--connector-link">
    <div *ngFor="let value of item.value; index as i" class="row__content-container">
      <span class="row__connector">AND</span>
      <a
        class="row__label link"
        target="_self"
        tabindex="0"
        [attr.aria-label]="'aria-label.table.link-item' | translate"
        (click)="onLinkClick(item.columnId, item.valueId[i])"
        >{{ value }}</a
      >
    </div>
    <span *ngIf="item.value?.length === 0" class="row__empty-label">{{ item.emptyValue | translate }}</span>
  </div>
</ng-template>

<ng-template #linkedDataList let-row>
  <div class="ecl-no-right-border">
    <p class="ecl-u-mt-none ee-linked-data-list-title">{{ tableConfig?.expandableRowTitle | translate }}</p>
    <div class="ecl-u-d-flex ecl-u-flex-wrap">
      <ng-container *ngFor="let item of row">
        <ng-container *ngIf="item?.columnId === 'linkedDataList' && item?.value?.length">
          <p *ngFor="let linkedItem of item?.value" class="ecl-u-pa-none ecl-u-mh-2xs ecl-u-mt-none ecl-u-mb-s ecl-u-mr-2xs">
            <a class="ee-chip" (click)="onChipClicked(linkedItem?.split('::')[0])">
              <span [euiTooltip]="linkedItem?.split('::')[1].length > 50 ? linkedItem?.split('::')[1] : ''">
                {{ linkedItem?.split('::')[1] | truncate: 50 }}
              </span>
            </a>
          </p>
        </ng-container>
      </ng-container>
    </div>
  </div>
</ng-template>
